// Code generated by "enumer -type=ExpressionType -json -text -yaml -sql"; DO NOT EDIT.

//
package expressionTypes

import (
	"database/sql/driver"
	"encoding/json"
	"fmt"
)

const _ExpressionTypeName = "NADateDayOfWeekEothinonExistsLukanCycleDayModeOfWeekMovableCycleDayParentheticalRealmSundayAfterElevationOfCrossSundaysBeforeTriodionYear"

var _ExpressionTypeIndex = [...]uint8{0, 2, 6, 15, 23, 29, 42, 52, 67, 80, 85, 112, 133, 137}

func (i ExpressionType) String() string {
	if i < 0 || i >= ExpressionType(len(_ExpressionTypeIndex)-1) {
		return fmt.Sprintf("ExpressionType(%d)", i)
	}
	return _ExpressionTypeName[_ExpressionTypeIndex[i]:_ExpressionTypeIndex[i+1]]
}

var _ExpressionTypeValues = []ExpressionType{0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12}

var _ExpressionTypeNameToValueMap = map[string]ExpressionType{
	_ExpressionTypeName[0:2]:     0,
	_ExpressionTypeName[2:6]:     1,
	_ExpressionTypeName[6:15]:    2,
	_ExpressionTypeName[15:23]:   3,
	_ExpressionTypeName[23:29]:   4,
	_ExpressionTypeName[29:42]:   5,
	_ExpressionTypeName[42:52]:   6,
	_ExpressionTypeName[52:67]:   7,
	_ExpressionTypeName[67:80]:   8,
	_ExpressionTypeName[80:85]:   9,
	_ExpressionTypeName[85:112]:  10,
	_ExpressionTypeName[112:133]: 11,
	_ExpressionTypeName[133:137]: 12,
}

// ExpressionTypeString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func ExpressionTypeString(s string) (ExpressionType, error) {
	if val, ok := _ExpressionTypeNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to ExpressionType values", s)
}

// ExpressionTypeValues returns all values of the enum
func ExpressionTypeValues() []ExpressionType {
	return _ExpressionTypeValues
}

// IsAExpressionType returns "true" if the value is listed in the enum definition. "false" otherwise
func (i ExpressionType) IsAExpressionType() bool {
	for _, v := range _ExpressionTypeValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for ExpressionType
func (i ExpressionType) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for ExpressionType
func (i *ExpressionType) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("ExpressionType should be a string, got %s", data)
	}

	var err error
	*i, err = ExpressionTypeString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for ExpressionType
func (i ExpressionType) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for ExpressionType
func (i *ExpressionType) UnmarshalText(text []byte) error {
	var err error
	*i, err = ExpressionTypeString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for ExpressionType
func (i ExpressionType) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for ExpressionType
func (i *ExpressionType) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = ExpressionTypeString(s)
	return err
}

func (i ExpressionType) Value() (driver.Value, error) {
	return i.String(), nil
}

func (i *ExpressionType) Scan(value interface{}) error {
	if value == nil {
		return nil
	}

	str, ok := value.(string)
	if !ok {
		bytes, ok := value.([]byte)
		if !ok {
			return fmt.Errorf("value is not a byte slice")
		}

		str = string(bytes[:])
	}

	val, err := ExpressionTypeString(str)
	if err != nil {
		return err
	}

	*i = val
	return nil
}
